#!/bin/sh
#
# Copyright (c) 2011  Peter Pentchev
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.

set -e

qpath=$QUILT_PATCHES
qrc="$HOME/.quiltrc"
if [ -z "$qpath" ] && [ -f "$qrc" ] && [ -r "$qrc" ]; then
	qpath=`sh -c ". \"$qrc\" > /dev/null 2>&1; echo \"\\\$QUILT_PATCHES\"" || true`
fi
if [ -z "$qpath" ]; then
	qpath='patches'
fi
if [ ! -d "$qpath" ]; then
	echo 'Could not find the quilt patches directory' 1>&2
	exit 1
fi

qtop=`quilt top`
if [ -z "$qtop" ]; then
	echo 'Could not query the top quilt patch' 1>&2
	exit 1
fi
qfile="$qpath/$qtop"
if [ ! -f "$qfile" ]; then
	echo "No top patch file $qfile" 1>&2
	exit 1
fi

quilt diff -p ab | interdiff -p1 "$qfile" /dev/stdin
